local function setCircles(fly)
	ux, uy = math.cos(fly.angle), math.sin(fly.angle)
	local dx, r = 3, 4
	fly.x0, fly.y0 = fly.x - dx*ux, fly.y - dx*uy
	fly.x1, fly.y1 = fly.x + dx*ux, fly.y + dx*uy
	fly.r = r
end

local function update(fly, dt)
	fly.x = fly.x + fly.speed * math.cos(fly.angle) * dt
	fly.y = fly.y + fly.speed * math.sin(fly.angle) * dt
	fly.angle = fly.angle + fly.turn * dt
	setCircles(fly)
end

local function draw(fly)
	love.graphics.circle('fill', fly.x0, fly.y0, fly.r)
	love.graphics.circle('fill', fly.x1, fly.y1, fly.r)
end

local methods = { update = update, draw = draw }
local class = { __index = methods }

local function new()
	local f = {
		x = math.random(math.floor(w/4), math.ceil(3*w/4)),
		y = math.random(math.floor(h/4), math.ceil(3*h/4)),
		speed = 500*math.random(),
		angle = 2*math.pi*math.random(),
		turn = (1 + 1 * math.random())*math.pi
	}
	setCircles(f)
	return setmetatable(f, class)
end

return { new = new, methods = methods, class = class }
